#Data acquisition

puts "Waiting for acquisition from ADC to be complete. \n Please make sure you have started the process from ucProbe..."
set startacq 0
set mm [ lindex [ get_service_paths master ] 0 ]
close_service master $mm
open_service master $mm

    set startacq [master_read_32 $mm 0x4a0000 1]
    set point [master_read_32 $mm 0x4a0014 1 ]
    master_write_32 $mm  $point 1
#   The following command will set the configuration word to be sent to the AD7689
#   Bellow are presented several examples of configuration words for selecting a different number of channels
#   By default, the Input channel configuration is bipolar, referenced to COM=VREF/2. The reference is External, internal buffer, temperature disabled.
#   Channel Sequencer is on, no temperature. No readback of current configuration
#   In the datasheet, CONFIGURATION REGISTER section, the format of this register is described. Different configuration words can be used.
#   Uncomment the line for the number of channels you want to acquire
#   1 differential channel
#   set command 0x207f
#   2 differential channels
#   set command 0x217f
#   3 differential channels
#   set command 0x227f
#   4 differential channels
    set command 0x237f

   master_write_16 $mm 0x4a0018 $command

    while { $startacq == 0 } {
        set startacq [master_read_32 $mm 0x4a0000 1]
    }
puts "Acquisition has been started..."
#maximum number of data bytes that can be acquired is 1048576
set data [ master_read_memory $mm 0x4e0000 16384 ]

master_write_32 $mm 0x4a0004 1

puts "Converting acquired data to 16 bit values"
for { set i 0 } { $i < [ llength $data ] } { incr i 2} {
    set a [ lindex $data $i ]
    set b [ lindex $data [ expr { $i + 1 } ] ]
    lappend newData [ expr  { ( $b << 8 ) + $a } ]
}

unset data

    puts "Processing data as two's complement"
    set final " "
    for { set i 0 } { $i < [ llength $newData ] } { incr i 8} {
        set a [ lindex $newData $i ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 1] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 2] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData  [expr $i + 3] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 4] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 5] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 6] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ],

        set a [ lindex $newData [expr $i + 7] ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
            set decimal [expr $decimal - 65535 ]
        }
        lappend final [expr $decimal ]\n
    }

unset newData

master_write_memory $mm 0x4a0008 1

puts "Moving data into file Acquisition.csv"
set fd [ open "Acquisition.csv" "a+" ]
fconfigure $fd -translation binary
puts -nonewline $fd [ join $final ]
close $fd
master_write_memory $mm 0x4a000C 1
unset final
puts "Iteration complete"
close_service master $mm
