#Data acquisition

puts "Waiting for acquisition from ADC to be complete. \n Please make sure you have started the process from ucProbe..."

set startacq 0

set mm [ lindex [ get_service_paths master ] 0 ]
close_service master $mm
open_service master $mm

    set startacq [master_read_32 $mm 0x4a0000 1]
    set point [master_read_32 $mm 0x4a0014 1 ]
    master_write_32 $mm $point 1
#   The following command will set the configuration word to be sent to the AD7689
#   Bellow are presented several examples of configuration words for selecting a different channel
#   By default, the Input channel configuration is bipolar, referenced to COM=VREF/2. The reference is External, internal buffer, temperature disabled. Channel Sequencer is off.
#   No readback of current configuration
#   In the datasheet, CONFIGURATION REGISTER section, the format of this register is described. Different configuration words can be used.
#   Uncomment the line for the number of the channel you want to acquire
#   channel 0
    set command 0x2879
#   channel 1
#   set command 0x28f9
#   channel 2
#   set command 0x2979
#   channel 3
#   set command 0x29f9
#   channel 4
#   set command 0x2a79
#   channel 5
#   set command 0x2af9
#   channel 6
#   set command 0x2b79
#   channel 7
#   set command 0x2bf9
#   temperature
#   set command 0x2c51

  master_write_16 $mm 0x4a0018 $command

    while { $startacq == 0 } {
        set startacq [master_read_32 $mm 0x4a0000 1]
    }

    puts "Acquisition has been started..."
#maximum number of data bytes that can be acquired is 1048576
    set data [ master_read_memory $mm 0x4e0000 16384 ]

    master_write_32 $mm 0x4a0004 1

    puts "Converting acquired data to 16 bit values"
    for { set i 0 } { $i < [ llength $data ] } { incr i 2} {
        set a [ lindex $data $i ]
        set b [ lindex $data [expr $i + 1 ] ]
        lappend newData [ expr  { ( $b << 8 ) + $a } ]
    }

    puts "Processing data as two's complement"
    set final " "
    for { set i 0 } { $i < [ llength $newData ] } { incr i} {
        set a [ lindex $newData $i ]
        set decimal [expr $a]
        if { $decimal > 32767 } {
             set decimal [expr $decimal - 65535 ]
         }
        lappend final [expr $decimal ]\n
        }

    unset data
    unset newData

    master_write_32 $mm 0x4a0008 1

    puts "Moving data into file Acquisition.csv"

    set fd [ open "Acquisition.csv" "a+" ]
    #fconfigure $fd -translation binary
    puts -nonewline $fd [ join $final ]
    close $fd
    master_write_32 $mm 0x4a000C 1
    unset final
    puts "Iteration complete"

close_service master $mm
