// Copyright (C) 1991-2011 Altera Corporation
// Your use of Altera Corporation's design tools, logic functions
// and other software and tools, and its AMPP partner logic
// functions, and any output files from any of the foregoing
// (including device programming or simulation files), and any
// associated documentation or information are expressly subject
// to the terms and conditions of the Altera Program License
// Subscription Agreement, Altera MegaCore Function License
// Agreement, or other applicable license agreement, including,
// without limitation, that your use is for the sole purpose of
// programming logic devices manufactured by Altera and sold by
// Altera or its authorized distributors.  Please refer to the
// applicable agreement for further details.

// *****************************************************************************
// This file contains a Verilog test bench template that is freely editable to
// suit user's needs .Comments are provided in each section to help the user
// fill out necessary details.
// *****************************************************************************
// Generated on "01/04/2012 15:23:13"

// Verilog Test Bench template for design : FPGA_block
//
// Simulation tool : ModelSim-Altera (Verilog)

`timescale 1 ns/ 1 ps
`include "ad7689_model.v"

module EvalBoard_top_tst();
// test vector input registers
reg [4:0] ad_i;
reg [15:0] treg_bd_io;
reg brd_n_i;
reg breset_i;
reg bwr_n_i;
//reg control_i;
reg dspclk_i;
reg m_clk_i;
// wires
wire adcok_o;
wire b_busy_o;
wire [15:0]  bd_io;
wire cnv_o;
wire din_o;
wire en_2p5v_n_o;
wire en_3p3v_n_o;
wire en_5p0v_n_o;
wire sck_o;
wire sdo_i;

reg b_busy_d1;
assign bd_io = (bwr_n_i == 1'b0) ? treg_bd_io : 16'hZZZZ;

EvalBoard_top i1 (
// port map - connection between master ports and signals/registers
    .ad_i(ad_i),
    .adcok_o(adcok_o),
    .b_busy_o(b_busy_o),
    .bd_io(bd_io),
    .brd_n_i(brd_n_i),
    .breset_i(breset_i),
    .bwr_n_i(bwr_n_i),
    .cnv_o(cnv_o),
    .din_o(din_o),
    .en_2p5v_n_o(en_2p5v_n_o),
    .en_3p3v_n_o(en_3p3v_n_o),
    .en_5p0v_n_o(en_5p0v_n_o),
    .m_clk_i(m_clk_i),
    .sck_o(sck_o),
    .sdo_i(sdo_i)
);
initial
begin
    ad_i        = 5'h4;
    treg_bd_io  = 16'h0;
    brd_n_i     = 1'b1;
    breset_i    = 1'b1;
    bwr_n_i     = 1;
    dspclk_i    = 0;
    m_clk_i     = 0;
#100 
    breset_i    = 0;
    treg_bd_io  = 16'h3fcf;
#100
    bwr_n_i     = 1'b0;
#100 
    bwr_n_i     = 1'b1;
#100
    bwr_n_i     = 1'b0;
#100
    bwr_n_i     = 1'b1;
    ad_i        = 5'h0;
$display("Running testbench ");
end

always
begin
    #5 m_clk_i =~ m_clk_i;
end

always
begin
    #11 dspclk_i =~dspclk_i;
end

ad7689_model i2(
    .din_i(din_o),
    .sck_i(sck_o),
    .cnv_i(cnv_o),
    .sdo_o(sdo_i)
);

always @(posedge dspclk_i)
begin
    b_busy_d1 <= b_busy_o ;

    if(b_busy_o == 1'b1 & b_busy_d1 == 1'b0)
    begin
         brd_n_i <= 1'b0;
    end
    else
    begin
        brd_n_i <= 1'b1;
    end
end

endmodule
